#include "StdAfx.h"
#include "WASDelGroup.h"
#include "ConvertUTF.h"
#include "MessengerActor.h"
#include "UtilFunction.h"
#include "GameTalkAPIGlobal.h"


CWASDelGroup::CWASDelGroup(CWASActor *pActor) : 
	CWASCommand(pActor)
{
}


CWASDelGroup::~CWASDelGroup(void)
{
}


void CWASDelGroup::ExecuteAsync()
{
	USES_UTF8_CONVERSION;

	CMessengerActor *pMessengerActor = static_cast<CMessengerActor *>(m_pActor->GetMessengerActor());
	if(pMessengerActor == NULL)
	{
		return;
	}	

	WSTRING strURL = m_pActor->GetWASServerAddress();
	strURL += _T("/ne/buddy/DelGroup.php");

	m_httpFacade.session().SetURL(W2U8(strURL.c_str()),	pMessengerActor->GetMessengerTicket());
	m_httpFacade.session().SetMethod(HTTP_METHOD_POST);

	m_httpFacade.session().AddBodyVariable("userid", W2U8(pMessengerActor->GetUserID()));

	char szID[64];
	sprintf(szID, "%d", m_nGroupID);
	m_httpFacade.session().AddBodyVariable("grpid", szID);
	m_httpFacade.session().AddBodyVariable("ticket", pMessengerActor->GetMessengerTicket());

	m_httpFacade.session().SetKeepRawHeader(TRUE);
	m_httpFacade.SendRequest(this);
}



bool CWASDelGroup::ParseAndEventFire(nfc::CIkXMLDom * pDom)
{
	// ó XML !!
	return true;
}


// override in drived class
void CWASDelGroup::OnWasResponse(trid_t trid,
								  bool bSuccess,
								  int /*nWinINetErrorCode*/, 
								  int /*nHttpResponseCode*/, 
                                  LPCSTR /*szWasResCodeInHeader*/, 
                                  LPCSTR szWasResCodeInXml,
                                  nfc::CIkXMLDom * pDom)
{
	if(bSuccess)
	{
		if(ParseAndEventFire(pDom) == false)
			m_eError = wasError_Protocol;
	}
	
	GT_ASSERT(m_pActor);
	CGTObserved<IGTWASActorEventPrivate>::listobserver_t observers;
	m_pActor->GetObserversEx(&observers);
	CGTObserved<IGTWASActorEventPrivate>::listobserver_t::iterator it = observers.begin();
	for (; it != observers.end(); ++it)
	{
		IGTWASActorEventPrivate *pObserver = static_cast<IGTWASActorEventPrivate *>(*it);
		if(pObserver->OnGTWASActor_ResponseDelGroup(m_pActor, GetID(), m_eError, m_nGroupID) == false)
			break;
	}
	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}


void CWASDelGroup::OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/)
{
	m_eError = wasError_Timeout;

	GT_ASSERT(m_pActor);
	CGTObserved<IGTWASActorEventPrivate>::listobserver_t observers;
	m_pActor->GetObserversEx(&observers);
	CGTObserved<IGTWASActorEventPrivate>::listobserver_t::iterator it = observers.begin();
	for (; it != observers.end(); ++it)
	{
		IGTWASActorEventPrivate *pObserver = static_cast<IGTWASActorEventPrivate *>(*it);
		if(pObserver->OnGTWASActor_ResponseDelGroup(m_pActor, GetID(), m_eError, m_nGroupID) == false)
			break;
	}
	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}
